#include <iostream>
using namespace std;

#include "damy.h"
#include "damy-random.h"

#include <cstdlib>
#include <ctime>

#define MAXITER 30

#define FILL(d1,d2,d3,d4,d5,d6,d7,d8) damy[0] = d1-1; damy[1] = d2-1; damy[2] = d3-1; damy[3] = d4-1; damy[4] = d5-1; damy[5] = d6-1; damy[6] = d7-1; damy[7] = d8-1;

#define TRYCYCLE(_var_) counter = 0; while((!_var_.Move()) && (counter < MAXITER)) { counter++; cout << "Stav po kroku [" << counter << "]: " << endl << _var_ << endl; }

#define DETERMFOOTER(_var_) if (counter == MAXITER) { cout << "Deterministicka heuristika selhala." << endl; } else { cout << "Deterministicka heuristika uspela: " << endl << _var_ << endl; }

#define RNDFOOTER(_var_) if (counter == MAXITER) { cout << "Heuristika s nahodnym vyberem selhala." << endl; } else { cout << "Heuristika s nahodnym vyberem uspela: " << endl << _var_ << endl; }

#define DETERMHEADER(_text_,_var_) cout << _text_ << " - deterministicka heuristika: " << endl << _var_ << endl;

#define RNDHEADER(_text_,_var_) cout << _text_ << " - heuristika s nahodnym vyberem: " << endl << _var_ << endl;


#define MAINCYCLED(d1,d2,d3,d4,d5,d6,d7,d8,iter,_text_) FILL(d1,d2,d3,d4,d5,d6,d7,d8) Node try##iter##D(damy); DETERMHEADER(_text_,try##iter##D) TRYCYCLE(try##iter##D) DETERMFOOTER(try##iter##D)
#define MAINCYCLER(d1,d2,d3,d4,d5,d6,d7,d8,iter,_text_) FILL(d1,d2,d3,d4,d5,d6,d7,d8) NodeRandom try##iter##R(damy); RNDHEADER(_text_,try##iter##R) TRYCYCLE(try##iter##R) RNDFOOTER(try##iter##R)

#define MAINCYCLE(d1,d2,d3,d4,d5,d6,d7,d8,iter,_text_) MAINCYCLED(d1,d2,d3,d4,d5,d6,d7,d8,iter,_text_) MAINCYCLER(d1,d2,d3,d4,d5,d6,d7,d8,iter,_text_)

#define MAINCYCLERND(iter,_text_) MAINCYCLED(rand()%8+1,rand()%8+1,rand()%8+1,rand()%8+1,rand()%8+1,rand()%8+1,rand()%8+1,rand()%8+1,iter,_text_) MAINCYCLER(rand()%8+1,rand()%8+1,rand()%8+1,rand()%8+1,rand()%8+1,rand()%8+1,rand()%8+1,rand()%8+1,iter,_text_)

int main()
{
	srand((unsigned)time(NULL));

	Pole damy;
	int counter = 0;

	MAINCYCLE(7,4,2,5,8,6,3,1,1,"Povinny priklad")
	MAINCYCLE(8,7,6,5,4,3,2,1,2,"Nepovinny priklad")	

	MAINCYCLERND(3,"Nahodny priklad 1")
	MAINCYCLERND(4,"Nahodny priklad 2")
	MAINCYCLERND(5,"Nahodny priklad 3")

	return 0;
}
